## libmawk 1.0.0

=== src/Makefile ===
all:
	cd libmawk && $(MAKE)
#	cd example_apps && $(MAKE) all

test:
	cd libmawk && $(MAKE) test

install:
	cd libmawk && $(MAKE) install
#	cd example_apps && $(MAKE) install

uninstall:
	cd libmawk && $(MAKE) uninstall
#	cd example_apps && $(MAKE) uninstall

linstall:
	cd libmawk && $(MAKE) linstall
#	cd example_apps && $(MAKE) linstall

clean:
#	cd example_apps && $(MAKE) clean
	cd awklib && $(MAKE) clean
	cd libmawk && $(MAKE) clean

distclean:
#	cd example_apps && $(MAKE) distclean
	cd awklib && $(MAKE) distclean
	cd libmawk && $(MAKE) distclean

=== src/libmawk/Makefile ===
# select alternative zmalloc schemes
# commented out: use the slab-like original zmalloc (default)
# _native: use malloc()/free() - useful for memory leak hunting
# _safemalloc: use auto-cleanup malloc - useful if malloc() is preferred over slabs but the context should be cleaned up
#ZMALLOC_FLAVOR = _native

# install these headers in $(INCDIR)/libmawk/
IHEADERS=libmawk.h mawk.h init.h code.h files.h memory.h zmalloc.h \
         symtype.h nstd.h types.h array.h sizes.h num.h num_int.h \
         num_double.h conf.h bi_vars.h vio.h cell.h repl.h array_orig.h \
         array_environ.h array_generic.h vio_orig.h vio_fifo.h zfifo.h \
         execute.h

MAWKMAN = $(MANDIR)/lmawk.$(MANEXT)

VIO_OBJ = files_children.o vio_orig.o

# common objects
CO=memory.o hash.o code.o vars.o da_bin.o da_common.o da_bin_helper.o error.o \
   bi_vars.o bi_funct_common.o array.o array_orig.o array_generic.o \
   field_common.o re_cmpl.o zmalloc$(ZMALLOC_FLAVOR).o fin_common.o files.o matherr.o fcall.o \
   version.o missing.o math_wrap.o cast.o cell.o scancode.o str.o \
   array_environ.o \
   $(VIO_OBJ) $(NUM_OBJ)

# parser objects
PO=parse.o scan.o da_text.o code_dump.o kw.o jmp.o

# execute objects
EO=execute.o bi_funct.o print.o debug.o field_exec.o split.o

REXP_O=rexp/rexp.o rexp/rexp0.o rexp/rexp1.o rexp/rexp2.o\
    rexp/rexp3.o

REXP_C=rexp/rexp.c rexp/rexp0.c rexp/rexp1.c rexp/rexp2.c\
    rexp/rexp3.c

# objects required for the buffer-vio
O_VIO_BUF=zfifo.o vio_fifo.o

# lib object
LO_ALL=$(CO) $(EO) $(PO) init.o libmawk.o fin_exec.o $(REXP_O) $(O_VIO_BUF)

# original all-in-one lmawk executable objects
O = main.o $(CO) $(EO) $(PO) init.o fin_exec.o viohack.o $(REXP_O)

# split shared object
O_COMP = bi_funct_dummy.o init.o print_dummy.o fin_comp.o $(PO) $(REXP_O)
O_EXEC = init_nocomp.o fin_exec.o $(O_VIO_BUF) $(EO) $(REXP_O)

# split executables
OBJ_COMP = main-comp.o viohack.o $(O_COMP) $(CO)
OBJ_EXEC = main-exec.o viohack.o  $(O_EXEC) $(CO)

all: mawk_and_test

include Makefile.conf

BINS = lmawk lmawk-comp lmawk-exec \
       libmawk.so libmawk.a \
       libmawk_common.so libmawk_comp.so libmawk_exec.so \
       regression/re_test/re_test

mawk_and_test : $(BINS)

libmawk.so: $(LO_ALL)
	$(CC) -shared $(LDFLAGS_RDYNAMIC) $(LDFLAGS) $(LDFLAGS_SO) -o libmawk.so $(LO_ALL) $(MATHLIB)

libmawk_comp.so: $(O_COMP)
	$(CC) -shared $(LDFLAGS_RDYNAMIC) $(LDFLAGS) -o libmawk_comp.so $(O_COMP) $(MATHLIB)

libmawk_exec.so: $(O_EXEC)
	$(CC) -shared $(LDFLAGS_RDYNAMIC) $(LDFLAGS) -o libmawk_exec.so $(O_EXEC) $(MATHLIB)

libmawk_common.so: $(CO)
	$(CC) -shared $(LDFLAGS_RDYNAMIC) $(LDFLAGS) -o libmawk_common.so $(CO) $(MATHLIB)

libmawk.a: $(LO_ALL)
	ar rvu $@ $(LO_ALL)
	ranlib $@

lmawk : $(O)
	$(CC) $(CFLAGS) -o lmawk $(O) $(MATHLIB)

lmawk-comp : $(OBJ_COMP)
	$(CC) $(CFLAGS) -o lmawk-comp $(OBJ_COMP) $(MATHLIB)

lmawk-exec : $(OBJ_EXEC)
	$(CC) $(CFLAGS) -o lmawk-exec $(OBJ_EXEC) $(MATHLIB)

main-comp.o: main.c
	$(CC) -c $(CFLAGS) -DMAWK_NO_EXEC=1 main.c -o main-comp.o

main-exec.o: main.c
	$(CC) -c $(CFLAGS) -DMAWK_NO_COMP=1 main.c -o main-exec.o


scancode.c :  makescan.c  scan.h
	$(CC) $(CFLAGS) -o makescan.exe  makescan.c
	rm -f scancode.c
	./makescan.exe > scancode.c
	rm makescan.exe


# compile regression tests implemented in C
# these rules are not in Makefiles under regression/, so
# all the $(CC) and $(CFLAGS) work without any extra hassle
RE_TEST_O = regression/re_test/re_test.o rexp/rexp.o rexp/rexp0.o rexp/rexp1.o rexp/rexp2.o rexp/rexp3.o zmalloc$(ZMALLOC_FLAVOR).o memory.o
regression/re_test/re_test: $(RE_TEST_O)
	$(CC) -o regression/re_test//re_test $(RE_TEST_O)

regression/re_test/re_test.o: regression/re_test/re_test.c
	$(CC) -c $(CFLAGS) regression/re_test/re_test.c -o regression/re_test/re_test.o

### misc: installation, clean, etc. ###

test: all
	cd regression && make

PWD=`pwd`

install_ :  lmawk libmawk.so
	$(MKDIR) $(BINDIR)
	$(MKDIR) $(MANDIR)
	$(MKDIR) $(INCDIR)
	$(MKDIR) $(LIBDIR)
	$(CP) $(PWD)/lmawk $(BINDIR)
	$(CHMODX)  $(BINDIR)/lmawk
	$(CP)  $(PWD)/man/lmawk.1  $(MAWKMAN)
	$(CHMOD)  0644  $(MAWKMAN)
	$(CP) $(PWD)/libmawk.so $(LIBDIR)/libmawk.so.$(SOVER1).$(SOVER2).$(SOVER3)
	rm $(LIBDIR)/libmawk.so.$(SOVER1).$(SOVER2) $(LIBDIR)/libmawk.so.$(SOVER1) 2>/dev/null ; true
	ln -s libmawk.so.$(SOVER1).$(SOVER2).$(SOVER3) $(LIBDIR)/libmawk.so.$(SOVER1).$(SOVER2)
	ln -s libmawk.so.$(SOVER1).$(SOVER2) $(LIBDIR)/libmawk.so.$(SOVER1)
	ln -s libmawk.so.$(SOVER1) $(LIBDIR)/libmawk.so
	for h in $(IHEADERS); do $(CP) $(PWD)/$$h $(INCDIR)/$$h; done
	$(CP) $(PWD)/../libmawk.h $(INCDIR)/../libmawk.h

install:
	make install_ CP="cp"

linstall:
	make install_ CP="ln -s"


rexp/rexp.o: rexp/rexp.c
	$(CC) -c $(CFLAGS) -o rexp/rexp.o rexp/rexp.c

rexp/rexp0.o: rexp/rexp0.c
	$(CC) -c $(CFLAGS) -o rexp/rexp0.o rexp/rexp0.c

rexp/rexp1.o: rexp/rexp1.c
	$(CC) -c $(CFLAGS) -o rexp/rexp1.o rexp/rexp1.c

rexp/rexp2.o: rexp/rexp2.c
	$(CC) -c $(CFLAGS) -o rexp/rexp2.o rexp/rexp2.c

rexp/rexp3.o: rexp/rexp3.c
	$(CC) -c $(CFLAGS) -o rexp/rexp3.o rexp/rexp3.c

$(NUM_OBJ): $(NUM_SRC) num.h

linstall: install

init_nocomp.o: init_nocomp.c
	$(CC) -c $(CFLAGS) -o init_nocomp.o init_nocomp.c

init_nocomp.o: init.c


clean :
	rm -f *.o rexp/*.o $(BINS)
	cd regression && make clean

distclean :  clean
	rm -f defines.out maxint.out conf.h Makefile.conf

include Makefile.dep

depend:
	@echo "# Generated by \"make depend\"" > Makefile.dep
	gcc $(CFLAGS) -MM `echo $(LO_ALL) | sed "s/\.o/.c/g"` >> Makefile.dep

FORCE:

=== debian/changelog ===
libmawk (1.0.0-3) unstable; urgency=medium

  * have -dev package depend on the lib package, closes: #916622

 -- Bdale Garbee <bdale@gag.com>  Mon, 24 Dec 2018 13:08:51 -0700

libmawk (1.0.0-2) unstable; urgency=medium

  * add LGPL-2.1+ reference for scconfig library to debian/copyright

 -- Bdale Garbee <bdale@gag.com>  Sun, 25 Nov 2018 12:58:08 -0700

libmawk (1.0.0-1) unstable; urgency=medium

  * initial packaging, with most of the work done by Tibor Palinkas 
  * patch symlink creation to meet Debian requirements, will be merged by
    upstream in the next release

 -- Bdale Garbee <bdale@gag.com>  Fri, 23 Nov 2018 11:12:09 -0700

## libmawk 1.0.1

=== src/libmawk/Makefile ===
--- 
+++ 
@@ -122,17 +122,30 @@
 install_ :  lmawk libmawk.so
 	$(MKDIR) $(BINDIR)
 	$(MKDIR) $(MANDIR)
+	$(MKDIR) $(MAN3DIR)
+	$(MKDIR) $(MAN7DIR)
 	$(MKDIR) $(INCDIR)
-	$(MKDIR) $(LIBDIR)
+	$(MKDIR) $(LIBARCHDIR)
 	$(CP) $(PWD)/lmawk $(BINDIR)
 	$(CHMODX)  $(BINDIR)/lmawk
 	$(CP)  $(PWD)/man/lmawk.1  $(MAWKMAN)
+	$(CP)  $(PWD)/man/libmawk_append_input.3libmawk         $(MAN3DIR)/libmawk_append_input.3libmawk
+	$(CP)  $(PWD)/man/libmawk_call_function.3libmawk        $(MAN3DIR)/libmawk_call_function.3libmawk
+	$(CP)  $(PWD)/man/libmawk_cell_destroy.3libmawk         $(MAN3DIR)/libmawk_cell_destroy.3libmawk
+	$(CP)  $(PWD)/man/libmawk_get_var.3libmawk              $(MAN3DIR)/libmawk_get_var.3libmawk
+	$(CP)  $(PWD)/man/libmawk_initialize.3libmawk           $(MAN3DIR)/libmawk_initialize.3libmawk
+	$(CP)  $(PWD)/man/libmawk_initialize_stage.3libmawk     $(MAN3DIR)/libmawk_initialize_stage.3libmawk
+	$(CP)  $(PWD)/man/libmawk_register_function.3libmawk    $(MAN3DIR)/libmawk_register_function.3libmawk
+	$(CP)  $(PWD)/man/libmawk_run_main.3libmawk             $(MAN3DIR)/libmawk_run_main.3libmawk
+	$(CP)  $(PWD)/man/libmawk_set_cell.3libmawk             $(MAN3DIR)/libmawk_set_cell.3libmawk
+	$(CP)  $(PWD)/man/libmawk_uninitialize.3libmawk         $(MAN3DIR)/libmawk_uninitialize.3libmawk
+	$(CP)  $(PWD)/man/example.7libmawk                      $(MAN7DIR)/example.7libmawk
 	$(CHMOD)  0644  $(MAWKMAN)
-	$(CP) $(PWD)/libmawk.so $(LIBDIR)/libmawk.so.$(SOVER1).$(SOVER2).$(SOVER3)
-	rm $(LIBDIR)/libmawk.so.$(SOVER1).$(SOVER2) $(LIBDIR)/libmawk.so.$(SOVER1) 2>/dev/null ; true
-	ln -s libmawk.so.$(SOVER1).$(SOVER2).$(SOVER3) $(LIBDIR)/libmawk.so.$(SOVER1).$(SOVER2)
-	ln -s libmawk.so.$(SOVER1).$(SOVER2) $(LIBDIR)/libmawk.so.$(SOVER1)
-	ln -s libmawk.so.$(SOVER1) $(LIBDIR)/libmawk.so
+	$(CP) $(PWD)/libmawk.so $(LIBARCHDIR)/libmawk.so.$(SOVER1).$(SOVER2).$(SOVER3)
+	rm $(LIBARCHDIR)/libmawk.so.$(SOVER1).$(SOVER2) $(LIBARCHDIR)/libmawk.so.$(SOVER1) 2>/dev/null ; true
+	ln -s libmawk.so.$(SOVER1).$(SOVER2).$(SOVER3) $(LIBARCHDIR)/libmawk.so.$(SOVER1).$(SOVER2)
+	ln -s libmawk.so.$(SOVER1).$(SOVER2).$(SOVER3) $(LIBARCHDIR)/libmawk.so.$(SOVER1)
+	ln -s libmawk.so.$(SOVER1) $(LIBARCHDIR)/libmawk.so
 	for h in $(IHEADERS); do $(CP) $(PWD)/$$h $(INCDIR)/$$h; done
 	$(CP) $(PWD)/../libmawk.h $(INCDIR)/../libmawk.h

=== debian/changelog ===
libmawk (1.0.1-1) unstable; urgency=medium

  * new upstream version
  * should build on s390x, closes: #914677

 -- Bdale Garbee <bdale@gag.com>  Tue, 26 Feb 2019 10:33:47 -0700

## libmawk 1.0.2

=== src/libmawk/Makefile ===
--- 
+++ 
@@ -126,7 +126,7 @@
 	$(MKDIR) $(MAN7DIR)
 	$(MKDIR) $(INCDIR)
 	$(MKDIR) $(LIBARCHDIR)
-	$(CP) $(PWD)/lmawk $(BINDIR)
+	$(CP) $(PWD)/lmawk $(BINDIR)/lmawk
 	$(CHMODX)  $(BINDIR)/lmawk
 	$(CP)  $(PWD)/man/lmawk.1  $(MAWKMAN)
 	$(CP)  $(PWD)/man/libmawk_append_input.3libmawk         $(MAN3DIR)/libmawk_append_input.3libmawk
@@ -149,6 +149,11 @@
 	for h in $(IHEADERS); do $(CP) $(PWD)/$$h $(INCDIR)/$$h; done
 	$(CP) $(PWD)/../libmawk.h $(INCDIR)/../libmawk.h
 
+uninstall:
+	$(RM) $(BINDIR)/lmawk $(MAWKMAN) $(MAN3DIR)/libmawk_append_input.3libmawk $(MAN3DIR)/libmawk_call_function.3libmawk $(MAN3DIR)/libmawk_cell_destroy.3libmawk $(MAN3DIR)/libmawk_get_var.3libmawk $(MAN3DIR)/libmawk_initialize.3libmawk $(MAN3DIR)/libmawk_initialize_stage.3libmawk $(MAN3DIR)/libmawk_register_function.3libmawk $(MAN3DIR)/libmawk_run_main.3libmawk $(MAN3DIR)/libmawk_set_cell.3libmawk $(MAN3DIR)/libmawk_uninitialize.3libmawk $(MAN7DIR)/example.7libmawk $(LIBARCHDIR)/libmawk.so.$(SOVER1).$(SOVER2).$(SOVER3) $(LIBARCHDIR)/libmawk.so.$(SOVER1).$(SOVER2) $(LIBARCHDIR)/libmawk.so.$(SOVER1) $(LIBARCHDIR)/libmawk.so
+	for h in $(IHEADERS); do $(RM) $(INCDIR)/$$h; done
+	$(RM) $(INCDIR)/../libmawk.h
+
 install:
 	make install_ CP="cp"
 
@@ -156,6 +161,7 @@
 	make install_ CP="ln -s"
 
 
+
 rexp/rexp.o: rexp/rexp.c
 	$(CC) -c $(CFLAGS) -o rexp/rexp.o rexp/rexp.c
 
@@ -172,8 +178,6 @@
 	$(CC) -c $(CFLAGS) -o rexp/rexp3.o rexp/rexp3.c
 
 $(NUM_OBJ): $(NUM_SRC) num.h
-
-linstall: install
 
 init_nocomp.o: init_nocomp.c
 	$(CC) -c $(CFLAGS) -o init_nocomp.o init_nocomp.c

=== debian/changelog ===
libmawk (1.0.2-3) unstable; urgency=medium

  * trivial patch to allow for compilation with GCC 10, closes: #957451

 -- Bdale Garbee <bdale@gag.com>  Fri, 07 Aug 2020 08:49:48 -0600

libmawk (1.0.2-2) unstable; urgency=medium

  * source-only upload to allow migration to testing, closes: #951449

 -- Bdale Garbee <bdale@gag.com>  Tue, 18 Feb 2020 11:47:33 -0700

libmawk (1.0.2-1) unstable; urgency=medium

  * new upstream version

 -- Bdale Garbee <bdale@gag.com>  Wed, 10 Jul 2019 10:28:24 -0600

=== debian/control ===
Source: libmawk
Section: libs
Priority: optional
Maintainer: Debian Electronics Team <pkg-electronics-devel@lists.alioth.debian.org>
Uploaders: Bdale Garbee <bdale@gag.com>
Build-Depends: debhelper (>= 11)
Standards-Version: 4.1.3
Homepage: http://repo.hu/projects/libmawk
Vcs-Git: https://salsa.debian.org/electronics-team/libmawk.git
Vcs-Browser: https://salsa.debian.org/electronics-team/libmawk

Package: libmawk1
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: embeddable mawk lib
 Libmawk is a fork of the popular awk implementation mawk, and aims to be
 the lightweight script language programmers embed in their application.
 .
 This implementation also supports some minor extensions over mawk:
  - dynamic awk function calls from awk scripts (by name in string)
  - dynamic variables (access variable by name in string)
  - include "scriptname.awk"
 .
 Besides the shared object, an lmawk binary is also installed, which is
 command-line-compatible with mawk but provides all those extra features.

Package: libmawk-dev
Section: libdevel
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}, libmawk1 (>= ${source:Version}), libmawk1 (<< ${source:Version}.1~)
Description: embeddable mawk lib
 Libmawk is a fork of the popular awk implementation mawk, and aims to be
 the lightweight script language programmers embed in their application.
 .
 This package constains all header files to allow applications to compile
 with embedded awk scripting.

=== debian/watch ===
version=3
opts=dversionmangle=s/\+repack.*$// \
  http://repo.hu/projects/libmawk/releases/libmawk-(.*)\.tar\.gz

## libmawk 1.0.4

=== src/Makefile ===
--- 
+++ 
@@ -1,5 +1,6 @@
 all:
 	cd libmawk && $(MAKE)
+	cd awklib && $(MAKE)
 #	cd example_apps && $(MAKE) all
 
 test:
@@ -7,14 +8,17 @@
 
 install:
 	cd libmawk && $(MAKE) install
+	cd awklib && $(MAKE) install
 #	cd example_apps && $(MAKE) install
 
 uninstall:
 	cd libmawk && $(MAKE) uninstall
+	cd awklib && $(MAKE) uninstall
 #	cd example_apps && $(MAKE) uninstall
 
 linstall:
 	cd libmawk && $(MAKE) linstall
+	cd awklib && $(MAKE) linstall
 #	cd example_apps && $(MAKE) linstall
 
 clean:

=== src/libmawk/regression/zfifo/Makefile ===
CFLAGS = -g -I.

OBJS=zfifo_test.o zfifo.o

all: zfifo_test

zfifo_test: $(OBJS)
	$(CC) $(OBJS) -o $@

zfifo.c zfifo.h: ../../zfifo.c ../../zfifo.h
	cp ../../zfifo.c .
	cp ../../zfifo.h .

zfifo.o: zfifo.c zfifo.h
	$(CC) -c $(CFLAGS) zfifo.c -o $@

zfifo_test.o: zfifo.h

clean:
	rm $(OBJS) zfifo_test zfifo.c zfifo.h 2>/dev/null; true

=== debian/changelog ===
libmawk (1.0.4-5) unstable; urgency=medium

  * move libmawk into the Ringdove suite on salsa
  * add -std=c17 to innoculate against gcc 15 changes, closes: #1097229

 -- Bdale Garbee <bdale@gag.com>  Sat, 06 Sep 2025 11:25:44 -0600

libmawk (1.0.4-4) unstable; urgency=high

  * fix parallel build race condition, closes: #1106399

 -- Bdale Garbee <bdale@gag.com>  Mon, 02 Jun 2025 12:10:13 -0600

libmawk (1.0.4-3) unstable; urgency=medium

  * disable link time optimization per upstream, closes: #1015502

 -- Bdale Garbee <bdale@gag.com>  Mon, 11 Mar 2024 12:06:08 -0600

libmawk (1.0.4-2) unstable; urgency=medium

  * fix build after build by cleaning harder, closes: #1045876

 -- Bdale Garbee <bdale@gag.com>  Mon, 11 Mar 2024 06:12:38 -0600

libmawk (1.0.4-1) unstable; urgency=medium

  * new upstream version, closes: #1065763

 -- Bdale Garbee <bdale@gag.com>  Mon, 11 Mar 2024 05:52:40 -0600

libmawk (1.0.2-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062412

 -- Benjamin Drung <bdrung@debian.org>  Wed, 28 Feb 2024 14:03:48 +0000

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,16 @@
 Priority: optional
 Maintainer: Debian Electronics Team <pkg-electronics-devel@lists.alioth.debian.org>
 Uploaders: Bdale Garbee <bdale@gag.com>
-Build-Depends: debhelper (>= 11)
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper (>= 11)
 Standards-Version: 4.1.3
 Homepage: http://repo.hu/projects/libmawk
-Vcs-Git: https://salsa.debian.org/electronics-team/libmawk.git
-Vcs-Browser: https://salsa.debian.org/electronics-team/libmawk
+Vcs-Git: https://salsa.debian.org/electronics-team/ringdove-eda/libmawk.git
+Vcs-Browser: https://salsa.debian.org/electronics-team/ringdove-eda/libmawk
 
-Package: libmawk1
+Package: libmawk1t64
+Provides: ${t64:Provides}
+Replaces: libmawk1
+Breaks: libmawk1 (<< ${source:Version})
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: embeddable mawk lib
@@ -27,7 +30,7 @@
 Package: libmawk-dev
 Section: libdevel
 Architecture: all
-Depends: ${misc:Depends}, ${shlibs:Depends}, libmawk1 (>= ${source:Version}), libmawk1 (<< ${source:Version}.1~)
+Depends: ${misc:Depends}, ${shlibs:Depends}, libmawk1t64 (>= ${source:Version}), libmawk1t64 (<< ${source:Version}.1~)
 Description: embeddable mawk lib
  Libmawk is a fork of the popular awk implementation mawk, and aims to be
  the lightweight script language programmers embed in their application.

=== debian/rules ===
#!/usr/bin/make -f

DH_VERBOSE = 1
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
export DEB_BUILD_MAINT_OPTIONS = optimize=-lto

# resolve FTBFS with gcc 15 until upstream comes up with a better solution
CFLAGS += -std=c17

%:
	dh $@

override_dh_auto_configure:
	./configure \
    --prefix=/usr \
    --LDFLAGS='$(LDFLAGS)' \
    --CFLAGS='$(CFLAGS) $(CPPFLAGS)'

override_dh_auto_clean:
	# only try to run dh_auto_clean if configure has been run
	test -f src/libmawk/Makefile.conf && dh_auto_clean || true
	# clean up some upstream make dregs
	rm -f scconfig/config.cache
	rm -f scconfig/config.log
	rm -f src/libmawk/regression/fpe/fpetest3.tmp
	rm -f src/libmawk/regression/zfifo/zfifo.c
	rm -f src/libmawk/regression/zfifo/zfifo.h

## libmawk 1.0.5

=== Makefile ===
all: src/libmawk/Makefile.conf
	cd src && $(MAKE)

install: src/libmawk/Makefile.conf
	cd src && $(MAKE) install
	cd doc && $(MAKE) install

uninstall:
	cd src && $(MAKE) uninstall

linstall: src/libmawk/Makefile.conf
	cd src && $(MAKE) linstall

clean:
	cd src && $(MAKE) clean

distclean:
	cd src && $(MAKE) distclean
	cd scconfig && $(MAKE) clean

test:
	cd src && $(MAKE) test

src/libmawk/Makefile.conf:
	@echo "Please run ./configure first."; false

=== doc/Makefile ===
all:

include ../src/libmawk/Makefile.conf

install:
	$(MKDIR) $(DOCDIR)
	$(CP) $(PWD)/*.html $(DOCDIR)

=== scconfig/Makefile ===
# --- configuration part --
SRC=src/
BIN=src/

# - generic configuration -
#  what cflags to use to compile scconfig
USER_CFLAGS = -g -DGENCALL

#  what ldflags to use to link scconfig
USER_LDFLAGS =

#  in case hooks.c needs to link to something local
USER_OBJS =

#  what to build - a ./configure
all: configure

# This line imports scconfig core and default tests
include src/default/Makefile.plugin

#
# - PLUGINS -
#
#  Comment this line if you are not interested in c99 features
#include src/c99/Makefile.plugin

#  Comment this line if you do not need script libs to be detected
#include src/scripts/Makefile.plugin

#  Comment this line if you do not need parser libs to be detected
#include src/parser/Makefile.plugin

#  Comment this line if you do not need to detect parser generators
include src/parsgen/Makefile.plugin

#  Comment this line if you do not need math related libs
include src/math/Makefile.plugin

#  Comment this line if you do not need socket/networking
#include src/socket/Makefile.plugin

#  Comment this line if you do not need tmpasm (templating)
include src/tmpasm/Makefile.plugin

# --- you shouldn't edit the lines below ---
OBJS = $(USER_OBJS) hooks.o $(DEFAULT_OBJS) $(SCRIPT_OBJS) $(PARSER_OBJS) $(TMPASM_OBJS) $(C99_OBJS) $(PARSGEN_OBJS) $(MATH_OBJS) $(SOCKET_OBJS)
CFLAGS = $(USER_CFLAGS) $(DEFAULT_CFLAGS) $(SCRIPT_CFLAGS) $(PARSER_CFLAGS) $(TMPASM_CFLAGS) $(C99_CFLAGS) $(PARSGEN_CFLAGS) $(MATH_CFLAGS) $(SOCKET_CFLAGS) -Isrc/default
LDFLAGS = $(USER_LDFLAGS) $(DEFAULT_LDFLAGS) $(SCRIPT_LDFLAGS) $(PARSER_LDFLAGS) $(TMPASM_LDFLAGS) $(C99_LDFLAGS) $(PARSGEN_LDFLAGS) $(MATH_LDFLAGS) $(SOCKET_LDFLAGS)

configure: $(OBJS)
	$(CC) -o configure $(OBJS)

clean:
	-rm $(OBJS) configure

=== src/example_apps/Makefile ===
APPS= \
 10_run \
 12_input \
 12_multi \
 15_call \
 15_get_array \
 15_get_scalar \
 20_init_wired \
 20_uninit_staged \
 25_set_array \
 30_out_pipes \
 31_out_pipes_manual \
 50_runlimit \
 51_blocking_fifo \
 70_c_func \
 71_c_func_call \
 90_custom_array \
 90_custom_vio \
 90_fn_validation \
 91_custom_vio_re

all:
	for n in $(APPS); do cd $$n && make all && cd ..; done

clean:
	for n in $(APPS); do cd $$n && make clean && cd ..; done

test:
	for n in $(APPS); do cd $$n && make -s test; cd ..; done

=== src/libmawk/Makefile ===
--- 
+++ 
@@ -142,7 +142,7 @@
 	$(CP)  $(PWD)/man/example.7libmawk                      $(MAN7DIR)/example.7libmawk
 	$(CHMOD)  0644  $(MAWKMAN)
 	$(CP) $(PWD)/libmawk.so $(LIBARCHDIR)/libmawk.so.$(SOVER1).$(SOVER2).$(SOVER3)
-	rm $(LIBARCHDIR)/libmawk.so.$(SOVER1).$(SOVER2) $(LIBARCHDIR)/libmawk.so.$(SOVER1) 2>/dev/null ; true
+	rm $(LIBARCHDIR)/libmawk.so $(LIBARCHDIR)/libmawk.so.$(SOVER1).$(SOVER2) $(LIBARCHDIR)/libmawk.so.$(SOVER1) 2>/dev/null ; true
 	ln -s libmawk.so.$(SOVER1).$(SOVER2).$(SOVER3) $(LIBARCHDIR)/libmawk.so.$(SOVER1).$(SOVER2)
 	ln -s libmawk.so.$(SOVER1).$(SOVER2).$(SOVER3) $(LIBARCHDIR)/libmawk.so.$(SOVER1)
 	ln -s libmawk.so.$(SOVER1) $(LIBARCHDIR)/libmawk.so

=== src/example_apps/15_call/Makefile ===
ROOT=../..

all: app

include $(ROOT)/libmawk/Makefile.conf
include ../Makefile.common

OBJS = app.o
CFLAGS = -I$(ROOT)

app: $(OBJS) $(ROOT)/libmawk/libmawk.a
	$(CC) $(LDFLAGS) $(OBJS) $(ROOT)/libmawk/libmawk.a -o $@ $(MATHLIB)

app.o: app.c

run: app
	./app -f test.awk

clean:
	rm -f $(OBJS) app

distclean: clean

=== src/example_apps/25_set_array/Makefile ===
ROOT=../..

all: app

include $(ROOT)/libmawk/Makefile.conf
include ../Makefile.common

OBJS = app.o
CFLAGS = -I$(ROOT)

app: $(OBJS) $(ROOT)/libmawk/libmawk.a
	$(CC) $(LDFLAGS) $(OBJS) $(ROOT)/libmawk/libmawk.a -o $@ $(MATHLIB)

app.o: app.c

run: app
	./app -f test.awk | sort

clean:
	rm -f $(OBJS) app

distclean: clean

=== src/example_apps/30_out_pipes/Makefile ===
ROOT=../..

all: app

include $(ROOT)/libmawk/Makefile.conf
include ../Makefile.common

OBJS = app.o
CFLAGS = -I$(ROOT)

app: $(OBJS) $(ROOT)/libmawk/libmawk.a
	$(CC) $(LDFLAGS) $(OBJS) $(ROOT)/libmawk/libmawk.a -o $@ $(MATHLIB)

app.o: app.c

run: app
	./app -f test.awk

clean:
	rm -f $(OBJS) app

distclean: clean

=== src/example_apps/50_runlimit/Makefile ===
ROOT=../..

all: app

include $(ROOT)/libmawk/Makefile.conf
include ../Makefile.common

OBJS = app.o
CFLAGS = -I$(ROOT)

app: $(OBJS) $(ROOT)/libmawk/libmawk.a
	$(CC) $(LDFLAGS) $(OBJS) $(ROOT)/libmawk/libmawk.a -o $@ $(MATHLIB)

app.o: app.c

run: app
	./app

clean:
	rm -f $(OBJS) app

distclean: clean

=== src/example_apps/51_blocking_fifo/Makefile ===
ROOT=../..

all: app

include $(ROOT)/libmawk/Makefile.conf
include ../Makefile.common

OBJS = app.o
CFLAGS = -g -I$(ROOT)

app: $(OBJS) $(ROOT)/libmawk/libmawk.a
	$(CC) $(LDFLAGS) $(OBJS) $(ROOT)/libmawk/libmawk.a -o $@ $(MATHLIB)

app.o: app.c

run: app
	./app

clean:
	rm -f $(OBJS) app

distclean: clean

=== src/example_apps/90_custom_array/Makefile ===
ROOT=../..

all: app

include $(ROOT)/libmawk/Makefile.conf
include ../Makefile.common

OBJS = app.o carr.o
CFLAGS = -I$(ROOT)

app: $(OBJS) $(ROOT)/libmawk/libmawk.a
	$(CC) $(LDFLAGS) $(OBJS) $(ROOT)/libmawk/libmawk.a -o $@ $(MATHLIB)

app.o: app.c

run: app
	./app -f test.awk

clean:
	rm -f $(OBJS) app

distclean: clean

=== src/example_apps/90_custom_vio/Makefile ===
ROOT=../..

all: app

include $(ROOT)/libmawk/Makefile.conf
include ../Makefile.common

OBJS = app.o vio_hash.o
CFLAGS = -I$(ROOT) -g

app: $(OBJS) $(ROOT)/libmawk/libmawk.a
	$(CC) $(LDFLAGS) $(OBJS) $(ROOT)/libmawk/libmawk.a -o $@ $(MATHLIB)

app.o: app.c

run: app
	./app -f test.awk

clean:
	rm -f $(OBJS) app

distclean: clean

=== debian/changelog ===
libmawk (1.0.5-1) unstable; urgency=medium

  * new upstream version

 -- Bdale Garbee <bdale@gag.com>  Wed, 17 Sep 2025 19:51:13 -0600

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Debian Electronics Team <pkg-electronics-devel@lists.alioth.debian.org>
 Uploaders: Bdale Garbee <bdale@gag.com>
-Build-Depends: dpkg-dev (>= 1.22.5), debhelper (>= 11)
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 11)
 Standards-Version: 4.1.3
 Homepage: http://repo.hu/projects/libmawk
 Vcs-Git: https://salsa.debian.org/electronics-team/ringdove-eda/libmawk.git

=== debian/watch ===
version=4
opts=dversionmangle=s/\+repack.*$// \
  http://repo.hu/projects/libmawk/releases/libmawk-(.*)\.tar\.gz
